/**
   chat: a TCP/IP chatting program
   Copyright (C) 2006  Idan Nof

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Idan Nof can be reached via -

   email: idannof (at) hotmail (dot) com
   web  : http://www.geocities.com/idannof
   paper: 3 Brande st.,
		  Petach-Tikva, 49600,
		  Israel
*/

/*
 * Created on 07/02/2006
 */
package Client;

import java.net.Socket;

import javax.swing.JFrame;

import Util.Config;

/**
 * @author idanno
 */
public class Gui extends JFrame {
	protected Client client = null;
	protected GuiEchoListener guiEchoListener = null;

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JTextArea jTextAreaServerEcho = null;
	private javax.swing.JButton jButtonDisconnect = null;
	private javax.swing.JButton jButtonConnect = null;
	private javax.swing.JLabel jLabelServerPort = null;
	private javax.swing.JTextField jTextFieldInputLine = null;
	private javax.swing.JTextField jTextFieldServerPort = null;
	private javax.swing.JTextField jTextFieldServerHostName = null;
	private javax.swing.JLabel jLabelServer = null;
	private javax.swing.JLabel jLabelUserName = null;
	private javax.swing.JTextField jTextFieldUserName = null;
	private javax.swing.JButton jButtonSendLine = null;

	/**
	 * This is the default constructor
	 */
	public Gui(Client client) {
		super();
		this.client = client;
		initialize();
		prolog();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(458, 246);
		this.setContentPane(getJContentPane());
		this.setTitle("Chat");
	}

	/**
	 * 
	 *
	 */
	protected void prolog() {
		guiEchoListener = new GuiEchoListener(jTextAreaServerEcho);
		guiEchoListener.start();
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			java.awt.GridBagConstraints consGridBagConstraints2 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints3 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints4 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints5 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints6 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints7 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints8 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints9 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints10 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints13 =
				new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints12 =
				new java.awt.GridBagConstraints();
			consGridBagConstraints13.gridy = 8;
			consGridBagConstraints13.gridx = 9;
			consGridBagConstraints7.fill =
				java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints7.weightx = 0.0D;
			consGridBagConstraints7.gridy = 2;
			consGridBagConstraints7.gridx = 1;
			consGridBagConstraints7.insets = new java.awt.Insets(0, 10, 0, 10);
			consGridBagConstraints7.anchor = java.awt.GridBagConstraints.NORTH;
			consGridBagConstraints8.fill =
				java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints8.weightx = 0.0D;
			consGridBagConstraints8.gridy = 4;
			consGridBagConstraints8.gridx = 1;
			consGridBagConstraints8.insets = new java.awt.Insets(0, 10, 0, 10);
			consGridBagConstraints8.gridwidth = 2;
			consGridBagConstraints6.fill =
				java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints6.weightx = 4.0D;
			consGridBagConstraints6.gridy = 8;
			consGridBagConstraints6.gridx = 8;
			consGridBagConstraints12.fill =
				java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints12.weightx = 0.0D;
			consGridBagConstraints12.gridy = 6;
			consGridBagConstraints12.gridx = 1;
			consGridBagConstraints12.insets = new java.awt.Insets(0, 10, 0, 10);
			consGridBagConstraints12.anchor = java.awt.GridBagConstraints.NORTH;
			consGridBagConstraints12.gridwidth = 2;
			consGridBagConstraints9.gridy = 4;
			consGridBagConstraints9.gridx = 0;
			consGridBagConstraints10.gridy = 6;
			consGridBagConstraints10.gridx = 0;
			consGridBagConstraints10.anchor =
				java.awt.GridBagConstraints.NORTHWEST;
			consGridBagConstraints4.gridy = 7;
			consGridBagConstraints4.gridx = 0;
			consGridBagConstraints5.gridy = 2;
			consGridBagConstraints5.gridx = 0;
			consGridBagConstraints2.ipady = 157;
			consGridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints2.weighty = 1.0;
			consGridBagConstraints2.weightx = 5.0D;
			consGridBagConstraints2.gridwidth = 2;
			consGridBagConstraints2.gridy = 1;
			consGridBagConstraints2.gridx = 8;
			consGridBagConstraints2.gridheight = 7;
			consGridBagConstraints5.fill = java.awt.GridBagConstraints.NONE;
			consGridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints3.gridy = 7;
			consGridBagConstraints3.gridx = 1;
			consGridBagConstraints9.anchor = java.awt.GridBagConstraints.WEST;
			consGridBagConstraints3.anchor = java.awt.GridBagConstraints.NORTH;
			consGridBagConstraints10.weightx = 0.0D;
			consGridBagConstraints7.gridwidth = 2;
			consGridBagConstraints4.anchor = java.awt.GridBagConstraints.NORTH;
			jContentPane.setLayout(new java.awt.GridBagLayout());
			jContentPane.add(getJTextAreaServerEcho(), consGridBagConstraints2);
			jContentPane.add(getJButtonDisconnect(), consGridBagConstraints3);
			jContentPane.add(getJButtonConnect(), consGridBagConstraints4);
			jContentPane.add(getJLabelServerPort(), consGridBagConstraints5);
			jContentPane.add(getJTextFieldInputLine(), consGridBagConstraints6);
			jContentPane.add(
				getJTextFieldServerPort(),
				consGridBagConstraints7);
			jContentPane.add(
				getJTextFieldServerHostName(),
				consGridBagConstraints8);
			jContentPane.add(getJLabelServer(), consGridBagConstraints9);
			jContentPane.add(getJLabelUserName(), consGridBagConstraints10);
			jContentPane.add(getJTextFieldUserName(), consGridBagConstraints12);
			jContentPane.add(getJButtonSendLine(), consGridBagConstraints13);
			jContentPane.setPreferredSize(new java.awt.Dimension(134, 201));
		}
		return jContentPane;
	}
	/**
	 * This method initializes jTextAreaServerEcho
	 * 
	 * @return javax.swing.JTextArea
	 */
	synchronized javax.swing.JTextArea getJTextAreaServerEcho() {
		if (jTextAreaServerEcho == null) {
			jTextAreaServerEcho = new javax.swing.JTextArea();
			jTextAreaServerEcho.setEditable(false);
			jTextAreaServerEcho.setText("");
		}
		return jTextAreaServerEcho;
	}
	/**
	 * This method initializes jButtonDisconnect
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonDisconnect() {
		if (jButtonDisconnect == null) {
			jButtonDisconnect = new javax.swing.JButton();
			jButtonDisconnect.setText("Disconnect");
			jButtonDisconnect
				.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					guiEchoListener.interrupt();
					client.doDisconnect();
					prolog();
				}
			});
		}
		return jButtonDisconnect;
	}
	/**
	 * This method initializes jButtonConnect
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConnect() {
		if (jButtonConnect == null) {
			jButtonConnect = new javax.swing.JButton();
			jButtonConnect.setText("Connect");
			jButtonConnect
				.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String host = getJTextFieldServerHostName().getText();
					Integer port =
						Integer.decode(getJTextFieldServerPort().getText());
					Socket s = client.doConnect(host, port.intValue());
					if (s != null)
						getJTextAreaServerEcho().append("Connected.\n");
					else
						getJTextAreaServerEcho().append("Unable to connect.");
				}
			});
		}
		return jButtonConnect;
	}
	/**
	 * This method initializes jLabelServerPort
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelServerPort() {
		if (jLabelServerPort == null) {
			jLabelServerPort = new javax.swing.JLabel();
			jLabelServerPort.setText("Server Port");
		}
		return jLabelServerPort;
	}
	/**
	 * This method initializes jTextFieldInputLine
	 * 
	 * @return javax.swing.JTextField
	 */
	javax.swing.JTextField getJTextFieldInputLine() {
		if (jTextFieldInputLine == null) {
			jTextFieldInputLine = new javax.swing.JTextField();
		}
		return jTextFieldInputLine;
	}
	/**
	 * This method initializes jTextFieldServerPort
	 * 
	 * @return javax.swing.JTextField
	 */
	javax.swing.JTextField getJTextFieldServerPort() {
		if (jTextFieldServerPort == null) {
			jTextFieldServerPort = new javax.swing.JTextField();

			String port = new Integer(Config.server_port).toString();
			jTextFieldServerPort.setText(port);
		}
		return jTextFieldServerPort;
	}
	/**
	 * This method initializes jTextFieldServerHostName
	 * 
	 * @return javax.swing.JTextField
	 */
	javax.swing.JTextField getJTextFieldServerHostName() {
		if (jTextFieldServerHostName == null) {
			jTextFieldServerHostName = new javax.swing.JTextField();

			String host = Config.server_host;
			jTextFieldServerHostName.setText(host);
		}
		return jTextFieldServerHostName;
	}
	/**
	 * This method initializes jLabelServer
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelServer() {
		if (jLabelServer == null) {
			jLabelServer = new javax.swing.JLabel();
			jLabelServer.setText("Server host");
		}
		return jLabelServer;
	}
	/**
	 * This method initializes jLabelUserName
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelUserName() {
		if (jLabelUserName == null) {
			jLabelUserName = new javax.swing.JLabel();
			jLabelUserName.setText("User name");
		}
		return jLabelUserName;
	}
	/**
	 * This method initializes jTextFieldUserName
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldUserName() {
		if (jTextFieldUserName == null) {
			jTextFieldUserName = new javax.swing.JTextField();
			jTextFieldUserName.setPreferredSize(new java.awt.Dimension(4, 19));
		}
		return jTextFieldUserName;
	}
	/**
	 * This method initializes jButtonSendLine
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonSendLine() {
		if (jButtonSendLine == null) {
			jButtonSendLine = new javax.swing.JButton();
			jButtonSendLine.setText("Send");

			jButtonSendLine
				.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					StaticFifos.getUserInput().put(
						getJTextFieldInputLine().getText());
				}
			});
		}
		return jButtonSendLine;
	}
} //  @jve:visual-info  decl-index=0 visual-constraint="52,15"
