/**
   chat: a TCP/IP chatting program
   Copyright (C) 2006  Idan Nof

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Idan Nof can be reached via -

   email: idannof (at) hotmail (dot) com
   web  : http://www.geocities.com/idannof
   paper: 3 Brande st.,
		  Petach-Tikva, 49600,
		  Israel
*/
package Client;

import Util.SynchedFifo;

/*
 * A static wrapper serving as a gate for messages between the GUI and it related threads to
 * the modules passing information to them.
 */
public class StaticFifos {
	/**
	 * FIFO for messages written on the server echo text area
	 */
	private SynchedFifo serverEcho = new SynchedFifo();
	
	/**
	 * FIFO for messages written on the user input field
	 */
	private SynchedFifo userInput = new SynchedFifo();
	
	/**
	 * A singelton hodler;
	 */
	private static StaticFifos myInstance = new StaticFifos();
	
	/**
	 * Returns our static server echo instance
	 * @return our static server echo instance
	 */
	public static SynchedFifo getServerEcho() {
		return myInstance.serverEcho;
	}
	
	/**
	 * Returns our static user input instance
	 * @return our static user input instance
	 */
	public static SynchedFifo getUserInput() {
		return myInstance.userInput;
	}
}
